#include <stdio.h>
#include <stdlib.h>
#include <check.h>

#include "libharkio3.h"

START_TEST(test_setlevel)
{
    harkio_Log_setLevel(harkio_Log_Error);
    harkio_Log_printf(harkio_Log_Info, "info msg");
    harkio_Log_printf(harkio_Log_Debug, "debug msg");
    harkio_Log_printf(harkio_Log_Warning, "warning msg");
    harkio_Log_printf(harkio_Log_Error, "error msg");

    harkio_Log_setLevel(harkio_Log_Warning);
    harkio_Log_printf(harkio_Log_Info, "info msg");
    harkio_Log_printf(harkio_Log_Debug, "debug msg");
    harkio_Log_printf(harkio_Log_Warning, "warning msg");
    harkio_Log_printf(harkio_Log_Error, "error msg");

    harkio_Log_setLevel(harkio_Log_Debug);
    harkio_Log_printf(harkio_Log_Info, "info msg");
    harkio_Log_printf(harkio_Log_Debug, "debug msg");
    harkio_Log_printf(harkio_Log_Warning, "warning msg");
    harkio_Log_printf(harkio_Log_Error, "error msg");

    harkio_Log_setLevel(harkio_Log_Info);
    harkio_Log_printf(harkio_Log_Info, "info msg");
    harkio_Log_printf(harkio_Log_Debug, "debug msg");
    harkio_Log_printf(harkio_Log_Warning, "warning msg");
    harkio_Log_printf(harkio_Log_Error, "error msg");
}
END_TEST

START_TEST(test_printlog)
{
    harkio_Log_printf(harkio_Log_Debug, "debug msg");
    harkio_Log_printf(harkio_Log_Warning, "warning msg");
    harkio_Log_printf(harkio_Log_Error, "error msg");
}
END_TEST

START_TEST(test_helper)
{
    harkio_Log_FileOpenFailed("test");
    harkio_Log_WrongValue("test1", "test2");
    harkio_Log_NullPointer("test");
}
END_TEST


Suite* str_suite(void)
{
    Suite *suite = suite_create("libharkio3_xml");

    TCase *tcase1 = tcase_create("new/delete");
    tcase_add_test(tcase1, test_setlevel);
    tcase_add_test(tcase1, test_printlog);
    tcase_add_test(tcase1, test_helper);
    suite_add_tcase(suite, tcase1);

    return suite;
}

int main(int argc, char *argv[])
{
    int number_failed;
    Suite *suite = str_suite();
    SRunner *runner = srunner_create(suite);
    srunner_run_all(runner, CK_NORMAL);
    number_failed = srunner_ntests_failed(runner);
    srunner_free(runner);
    return number_failed;
}
